// Luc Hanneuse CC BY NC 4.0
PrintWriter output;// to write to a file
float z = 30.0;
float x = 100.0;
float y = 100.0;
float step = 0.3;
float e = 5.0;
float feed = 300;

void setup() {
  output = createWriter("mysuper.gcode"); // Create a new file in the sketch directory
  //output.println("G21"); // header gcode
  //output.println("G91"); // header gcode
  //output.println("M109 S220");
  
  output.println("M104 S220");
  output.println("M109 S220");
  output.println("G4 1000");
  output.println("M83"); //extrusion relative
  output.println("G1 F" + feed + " E10.0");
  output.println("G1 X" + x + " Y" + y + " Z" + z + " E1.0");
  
  size(640, 360);
  
  ncircle(10,20);
  x = 100.0; y = 100.0;
  ncircle(10,20);
   
}

void draw() {
  background(102);
  translate(width*0.5, height*0.5);
  
}

void keyPressed() {
  output.flush(); // Writes the remaining data to the file
  output.close(); // Finishes the file
  exit(); // Stops the program
}

void square(float wide, float lenght) {
  writegcode();
  x = x + wide;
  writegcode();
  y = y + lenght;
  writegcode();
  x = x - wide;
  writegcode();
  y = y - lenght;
}

void translate(float xmove, float ymove){
  x = x + xmove;
  y = y + ymove;
}

//https://en.wikipedia.org/wiki/Rotation_(mathematics)#Two_dimensions
void rotate(float angle){
  x = x * cos(angle) - y * sin(angle) ;
  y = x * sin(angle) + y * cos(angle) ;
}

void writegcode(){
   output.println("G1 X" + x + " Y" + y + " E" + e );
  //G1 X100 Y100 Z0.3 E20 typical gcode
}

//https://en.wikipedia.org/wiki/Circle#Equations
void ncircle(float radius, int n){
  for (int i = 1; i < (n+2); i = i+1){
    float angle = 2 * PI / n * i;
    x = x + radius * cos(angle);
    y = y + radius * sin(angle);
    writegcode();
  }

}
